dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y, rot, scl_x, scl_y = EntityGetTransform( entity_id )
local hitboxes = EntityGetComponent(entity_id, "HitboxComponent" )


local vel_x=0
local vel_y=0
local oldvel_x=0
local oldvel_y=0
local oldspd=0
local newspd=0

local tryvels=EntityGetComponent(entity_id, "VelocityComponent" )
if (tryvels==nil) then --if it doesn't have a VelocityComponent already, we must add one, and then get the velocities

	EntityAddComponent( entity_id, "VelocityComponent", 
	{
	}
	)
	
end

edit_component( entity_id, "VelocityComponent", function(comp,vars)

	vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)

	
	
	
	local chx=0
	local chy=0
	
	local hbx1=0
	local hbx2=0
	local hby1=0
	local hby2=0
	
	if( hitboxes ~= nil ) then
		for i,hitbox in ipairs(hitboxes) do
		
			hbx1=ComponentGetValueInt( hitbox, "aabb_min_x")
			hbx2=ComponentGetValueInt( hitbox, "aabb_max_x")
			hby1=ComponentGetValueInt( hitbox, "aabb_min_y")
			hby2=ComponentGetValueInt( hitbox, "aabb_max_y")
			
		end
	end
	
	
	oldvel_x=vel_x
	oldvel_y=vel_y
	oldspd=math.sqrt( (oldvel_x)^2 + (oldvel_y)^2 )
	
	local scale = math.max(4,oldvel_y)--math.sqrt( (vel_x)^2 + (vel_y)^2 )
	local adjustment = -1
	
	local distout=8

	local normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x, pos_y+distout+hby2, distout, 16 )
	
	if normalfound then
		vel_x = vel_x - normalx*.25*scale
		vel_y = vel_y - normaly*1*scale

	end

	
	scale = math.max(4,-oldvel_y)
	normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x, pos_y-distout+hby1, distout, 16 )
	
	if normalfound then
		vel_x = vel_x - normalx*.25*scale
		vel_y = vel_y - normaly*1*scale
	end
	
	
	scale = math.max(4,oldvel_x)
	normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x+distout+hbx2, pos_y, distout, 16 )
	
	if normalfound then
		vel_x = vel_x - normalx*1*scale
		vel_y = vel_y - normaly*.25*scale

	end
	
	
	scale = math.max(4,-oldvel_x)
	normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x-distout+hby1, pos_y, distout, 16 )
	
	if normalfound then
		vel_x = vel_x - normalx*1*scale
		vel_y = vel_y - normaly*.25*scale

	end
	
	newspd=math.max(1,math.sqrt( (vel_x)^2 + (vel_y)^2 ))
	
	ComponentSetValueVector2( comp, "mVelocity", vel_x*oldspd/newspd, vel_y*oldspd/newspd)
	
	
	
end)


PhysicsApplyForce( entity_id, vel_x*oldspd/newspd-oldvel_x, vel_y*oldspd/newspd-oldvel_y )