dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )
local hitboxes = EntityGetComponent(entity_id, "HitboxComponent" )


local vel_x=0
local vel_y=0
local oldvel_x=0
local oldvel_y=0
local targetspd=500
local newspd=0


edit_component( entity_id, "VelocityComponent", function(comp,vars)

	GamePrintImportant("test","is")

	--save current speed vectors
	oldvel_x,oldvel_y = ComponentGetValueVector2( comp, "mVelocity", oldvel_x, oldvel_y)
	local oldspd=math.max(1,math.sqrt( (oldvel_x)^2 + (oldvel_y)^2 ))
	targetspd=500
	
	--two hitscans in opposing perpendiculars to the current direction
	local distout=8
	oldvel_x=distout*oldvel_x/oldspd
	oldvel_y=distout*oldvel_y/oldspd
	
	local normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x-oldvel_y, pos_y+oldvel_x, 8, 16 )
	local scale=1
	
	if normalfound then
		--push or pull according to the distance, in the corresponding perpendicular
		--note: this is wrong because the point can be either closer or farther to the projetile than where the rays originated
		scale=(normaldist-distout/2)/(distout/2)
		vel_x = vel_x + normalx*scale
		vel_y = vel_y - normaly*scale
		
		--find the normal's perpendicular that is least different from the original direction
		local angle=math.atan2(normaly,normalx)
		local ang_x=math.cos(angle+math.pi/2)
		local ang_y=math.sin(angle+math.pi/2)
		
		
		
		local axs=0
		local oxs=0
		local ays=0
		local oys=0
		if (ang_x>0) then
			axs=1
		elseif (ang_x<0) then
			axs=-1
		end
		
		if (oldvel_x>0) then
			oxs=1
		elseif (oldvel_x<0) then
			oxs=-1
		end
		
		if (ang_y>0) then
			ays=1
		elseif (ang_y<0) then
			ays=-1
		end
		
		if (oldvel_y>0) then
			oys=1
		elseif (oldvel_y<0) then
			oys=-1
		end
		
		
		if (axs=-oxs and ays=-oys) then
			ang_x=-ang_x
			ang_y=-ang_y
		end
		
		--contribute to the intended direction
		vel_x=vel_x+ang_x
		vel_y=vel_y+ang_y
		
	end

	local normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x+oldvel_y, pos_y+oldvel_x, 8, 16 )
	
	if normalfound then
		--push or pull according to the distance, in the corresponding perpendicular
		--note: this is wrong because the point can be either closer or farther to the projetile than where the rays originated
		scale=(normaldist-distout/2)/(distout/2)
		vel_x = vel_x + normalx*scale
		vel_y = vel_y + normaly*scale
		
		--find the normal's perpendicular that is least different from the original direction
		local angle=math.atan2(normaly,normalx)
		local ang_x=math.cos(angle+math.pi/2)
		local ang_y=math.sin(angle+math.pi/2)
		
		local axs=0
		local oxs=0
		local ays=0
		local oys=0
		if (ang_x>0) then
			axs=1
		elseif (ang_x<0) then
			axs=-1
		end
		
		if (oldvel_x>0) then
			oxs=1
		elseif (oldvel_x<0) then
			oxs=-1
		end
		
		if (ang_y>0) then
			ays=1
		elseif (ang_y<0) then
			ays=-1
		end
		
		if (oldvel_y>0) then
			oys=1
		elseif (oldvel_y<0) then
			oys=-1
		end
		
		
		if (axs=-oxs and ays=-oys) then
			ang_x=-ang_x
			ang_y=-ang_y
		end
		
		--contribute to the intended direction
		vel_x=vel_x+ang_x
		vel_y=vel_y+ang_y
		
	end
	

	newspd=math.max(1,math.sqrt( (vel_x)^2 + (vel_y)^2 ))
	targetspd=targetspd*.9+newspd*.1
	
	--set speed to OR closer to desired speed
	ComponentSetValueVector2( comp, "mVelocity", vel_x*targetspd/newspd, vel_y*targetspd/newspd)
	
	
	
end)