dofile_once( "data/scripts/game_helpers.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "mods/toastline_pack/config.lua" )

function item_pickup( entity_item, entity_who_picked, item_name )
	local pos_x, pos_y = EntityGetTransform( entity_item )
	
	local damagemodels = EntityGetComponent( entity_who_picked, "DamageModelComponent" )
	local value=1
	edit_component_with_tag( entity_item, "VariableStorageComponent", "hcontainer_value", function(comp,vars) value=ComponentGetValue( comp, "value_int") end )
	
	
	
		local extra_money_count = GameGetGameEffectCount( entity_who_picked, "EXTRA_MONEY" )
		if extra_money_count > 0 then
			for i=1,extra_money_count do
				value = value * 2
			end
		end
	
	
	if( damagemodels ~= nil ) then
		for i,v in ipairs(damagemodels) do
			currenthp = tonumber( ComponentGetValue( v, "hp" ) )
			current_max_hp = tonumber( ComponentGetValue( v, "max_hp") )
			
			local targethp = currenthp + (value*HealAmount * 0.04) -- Health values are scaled up by 25 in the UI apparently. So using this multiplier will allow the correct hp to be set
			local target_max_hp = current_max_hp + (MaxHealthIncrease * 0.04)
			

			--GamePrint(tostring(value*HealAmount))
			ComponentSetValue( v, "max_hp", target_max_hp)
			if( targethp > target_max_hp ) then targethp = target_max_hp end
			ComponentSetValue( v, "hp", targethp)
			break
		end
	end

	GamePlaySound("mods/toastline_pack/files/health_container_audio.snd", "health_container/hc_heal", pos_x, pos_y)
	shoot_projectile( entity_item, "mods/toastline_pack/files/data/entities/particles/health_container_pickup.xml", pos_x, pos_y, 0, 0 )
	EntityKill( entity_item )
end
