dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once("mods/toastline_pack/config.lua")
dofile_once( "data/scripts/perks/perk_list.lua" )

local Time = 60
local RegenAmount = SegRegenAmountConfig / 25 / Time
local last_max_hp = 100 / 25
local last_hp = 100 / 25
local timer=0
local gui=GuiCreate()


if (PP_Perk) then
	ModRegisterAudioEventMappings( "mods/toastline_pack/files/audio_events.txt" )
	ModMaterialsFileAdd( "mods/toastline_pack/files/materials_healthcontainer_box2d.xml" )
	ModLuaFileAppend( "data/scripts/perks/perk_list.lua", "mods/toastline_pack/files/peppy_pauper.lua" )
end

if (Seg_Perk) then
	ModLuaFileAppend( "data/scripts/perks/perk_list.lua", "mods/toastline_pack/files/segmentperk/segmentperk.lua" )
end

function OnWorldPreUpdate()

	if (Seg_Perk) then
		
		if( GameHasFlagRun( get_perk_picked_flag_name( "SEGMENTED_REGENERATION" ) ) )  then
			
			-- Regeneration --
			local player_entity = ( EntityGetWithTag( "player_unit" ) ) [1]
			local player_damagemodel = EntityGetComponent( player_entity, "DamageModelComponent" )
			
			
			if( player_damagemodel ~= nil ) then
				for i, damagemodel in ipairs( player_damagemodel ) do
					hp = tonumber( ComponentGetValue( damagemodel, "hp" ) )
					max_hp = tonumber( ComponentGetValue( damagemodel, "max_hp" ) )
					
					--local max_hp_cap = tonumber( ComponentGetValue( damagemodel, "max_hp_cap" ) )
					--local projectile_damage = tonumber( ComponentObjectGetValue( damagemodel, "damage_multipliers", "projectile" ) )
					--local explosion_damage = tonumber( ComponentObjectGetValue( damagemodel, "damage_multipliers", "explosion" ) )
					if( hp < max_hp) then
						local edit=0
						if( player_entity ~= nil ) then
							
							edit_all_components( player_entity, "VariableStorageComponent", function(comp,vars)
								if (ComponentGetValue( comp, "name")=="prpp") then
									edit=edit+tonumber(ComponentGetValue( comp, "value_int"))
									
								end
							end)
						end
						
						
						local target=math.min(max_hp*25, math.ceil(hp*25/(RegenSegmentSize*edit)) * RegenSegmentSize*edit)
						
						if (math.ceil(hp*25)<math.ceil(last_hp*25)) then
							timer=SegRegenDelay
							
						elseif (hp>last_hp) then--if our HP was increased by something else, then reduce the effectiveness of this regen; otherwise even tiny constant regen from another source would trigger the super fast regen of this, and it would go all the way to full health
							if (target>math.min(last_max_hp*25, math.ceil(last_hp*25/(RegenSegmentSize*edit)) * RegenSegmentSize*edit)) then
								timer=SegUpRegenDelay
								
							end
						end
						
						
						
						if (timer<=0) then
							
								
								if (math.floor(hp*25) < math.ceil(target)) then
									
									hp = math.min( target/25, hp + (RegenAmount*edit) )
									if (hp>=target/25) then
										timer=SegUpRegenDelay
										
									end
								end
								
								if( hp < 0 ) then
									hp = 0
								end
								
								
							
						else
							timer=math.max(0,timer-1)
						end
					
						if( hp >= max_hp ) then
							hp = max_hp
						end
					
					ComponentSetValue( damagemodel, "hp", hp )
					--ComponentSetValue( damagemodel, "max_hp", max_hp )
					--ComponentSetValue( damagemodel, "max_hp_cap", max_hp_cap )
					
					end

					last_max_hp = max_hp
					last_hp = hp
				end
			end
		end
	end
	
	
end

function OnModPreInit()
	print("Mod - OnModPreInit()")

end

function OnModInit()
	print("Mod - OnModInit()")
	
	
end

function OnModPostInit()
	print("Mod - OnModPostInit()")
end

function OnPlayerSpawned( player_entity )

end

ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/toastline_pack/files/actions.lua" )
